aboutsummaryrefslogtreecommitdiff
path: root/scripts
diff options
context:
space:
mode:
authorDenis Vlasenko <vda.linux@googlemail.com>2007-08-12 20:58:27 +0000
committerDenis Vlasenko <vda.linux@googlemail.com>2007-08-12 20:58:27 +0000
commit6ca409e0e4c198fe3081346eebbae3f068fe605a (patch)
tree060cb05d99220a1eda399194d1209c269f0e8cd8 /scripts
parent4185548984357df91311f30c8e43d95f33922576 (diff)
downloadbusybox-6ca409e0e4c198fe3081346eebbae3f068fe605a.tar.gz
trylink: produce even more info about final link stage
trylink: explain how to modify link and drastically decrease amount of padding (unfortunately, needs hand editing ATM). *: add ALIGN1 / ALIGN2 to global strings and arrays of bytes and shorts size saving: 0.5k
Diffstat (limited to 'scripts')
-rwxr-xr-xscripts/mkconfigs2
-rwxr-xr-xscripts/trylink41
2 files changed, 28 insertions, 15 deletions
diff --git a/scripts/mkconfigs b/scripts/mkconfigs
index d212ad408..0d1771a36 100755
--- a/scripts/mkconfigs
+++ b/scripts/mkconfigs
@@ -44,7 +44,7 @@ echo "\
* Do not edit.
*
*/
-static const char * const bbconfig_config ="
+static const char *const bbconfig_config ="
sed 's/\"/\\\"/g' $config | grep "^#\? \?CONFIG_" | awk '{print "\"" $0 "\\n\"";}'
diff --git a/scripts/trylink b/scripts/trylink
index 74acb4cdd..9b67deb49 100755
--- a/scripts/trylink
+++ b/scripts/trylink
@@ -6,7 +6,7 @@ try() {
added="$1"
shift
$debug && echo "Trying: $* $added"
- "$@" $added >busybox.map 2>busybox_ld.err
+ "$@" $added 2>busybox_ld.err
}
# Sanitize lib list (dups, extra spaces etc)
@@ -22,14 +22,17 @@ try "-Wl,--start-group $l_list -Wl,--end-group" "$@" \
cat busybox_ld.err
exit 1
}
-# Hack: we are not supposed to know executable name,
-# but this hack cuts down link time
-mv busybox_unstripped busybox_unstripped.tmp
-mv busybox.map busybox.map.tmp
+
+#### Hack disabled: conflicts with ld --verbose flag in last link phase
+
+##### Hack: we are not supposed to know executable name,
+##### but this hack cuts down link time
+####mv busybox_unstripped busybox_unstripped.tmp
+####mv busybox.map busybox.map.tmp
# Now try to remove each lib and build without it.
# Stop when no lib can be removed.
-ever_discarded=false
+####ever_discarded=false
while test "$BBOX_LIB_LIST"; do
$debug && echo "Trying libraries: $BBOX_LIB_LIST"
all_needed=true
@@ -41,7 +44,7 @@ while test "$BBOX_LIB_LIST"; do
echo "Library $one is not needed"
BBOX_LIB_LIST="$without_one"
all_needed=false
- ever_discarded=true
+#### ever_discarded=true
else
echo "Library $one is needed"
fi
@@ -54,13 +57,23 @@ while test "$BBOX_LIB_LIST"; do
#{ echo "$BBOX_LIB_LIST" | grep -q ' '; } || break
done
-mv busybox_unstripped.tmp busybox_unstripped
-mv busybox.map.tmp busybox.map
-$ever_discarded && {
+####mv busybox_unstripped.tmp busybox_unstripped
+####mv busybox.map.tmp busybox.map
+####$ever_discarded && {
# Make the binary with final, minimal list of libs
echo "Final link with: $BBOX_LIB_LIST"
l_list=`echo "$BBOX_LIB_LIST" | sed -e 's/ / -l/g' -e 's/^/-l/'`
- try "-Wl,--start-group $l_list -Wl,--end-group" "$@" || exit 1
-}
-rm busybox_ld.err
-exit 0 # Ensure "success" exit code
+ # --verbose gives us gobs of info to stdout (e.g. linker script used)
+ try "-Wl,--start-group $l_list -Wl,--end-group -Wl,--verbose" "$@" >busybox_ld.out ####|| exit 1
+ #
+ # Add SORT_BY_ALIGNMENT to linker script (found in busybox_ld.out):
+ # .rodata : { *(.rodata SORT_BY_ALIGNMENT(.rodata.*) .gnu.linkonce.r.*) }
+ # *(.data SORT_BY_ALIGNMENT(.data.*) .gnu.linkonce.d.*)
+ # *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
+ # This will eliminate most of the data padding. Use linker script
+ # by commenting "try" above and uncommenting this one (tested on i386):
+ #try "-Wl,--start-group $l_list -Wl,--end-group -Wl,--verbose -Wl,-T -Wl,busybox_ldscript" "$@" >busybox_ld.out
+ #
+####}
+####rm busybox_ld.err
+####exit 0 # Ensure "success" exit code